#N canvas 645 233 502 534 10;
#X obj 247 289 nbx 5 14 1 10 0 1 empty \$0-markovOrder markovOrder
0 -8 0 10 -257985 -1 -1 5 256;
#N canvas 396 136 450 262 markovInputList 0;
#X obj 62 101 list-drip;
#X obj 62 126 list prepend add2;
#X obj 62 146 list trim;
#X msg 45 167 markovInputList 11 10 9 9 9 8 8 8 8 8 8 8 8 8 9 10 11
13 15 17 18 18 16 15 13 11 11 11 11 11 12 12 13 13 14 14 15 16 17 19
20 22 23 24 26 25 24 17 14 11 10 10 11 11 12 13 14 17 20 24 19 17 15
12 11 18 18;
#X msg 96 59 set;
#X msg 79 80 markovInputList;
#X obj 45 17 inlet;
#X obj 45 199 outlet;
#X obj 45 38 t b a b b;
#X connect 0 0 1 0;
#X connect 1 0 2 0;
#X connect 2 0 3 0;
#X connect 3 0 7 0;
#X connect 4 0 3 0;
#X connect 5 0 1 0;
#X connect 6 0 8 0;
#X connect 8 0 3 0;
#X connect 8 1 0 0;
#X connect 8 2 5 0;
#X connect 8 3 4 0;
#X restore 38 118 pd markovInputList;
#X msg 197 145 markovChain;
#X obj 206 183 nbx 5 14 1 67 0 1 empty \$0-markovChainLength markovChainLength
0 -8 0 10 -257985 -1 -1 67 256;
#X msg 206 202 markovChainLength \$1;
#X obj 38 308 ofelia d -c21 -k \$0-markovGenerator;
#A set function ofelia.list(fv) \; \; math.randomseed(os.time()- os.clock()
* 1000) \; \; print("Lua Markov Generator") \; \; -- make dictionary
\; \; local function defaultdict(default_value_factory) \; \; local
t = {} \; local metatable = {} \; metatable.__index = function(t \,
key) \; if not rawget(t \, key) then \; rawset(t \, key \, default_value_factory(key))
\; end \; return rawget(t \, key) \; end \; return setmetatable(t \,
metatable) \; end \; \; -- make markov matrix \; \; local model = defaultdict(function()
return {} end) \; local markovOrder = fv[1] \; print("Markov Order:
" \, math.floor(markovOrder)) \; local data = {} \; for i = 1 \, #ofelia.markovInputList
do \; data[i] = ofelia.markovInputList[i] \; end \; print("Data Size:
" \, #ofelia.markovInputList) \; for i = 1 \, markovOrder do \; table.insert(data
\, data[i]) \; end \; for i = 1 \, #data - markovOrder do \; local
state = {table.unpack(data \, i \, i + markovOrder - 1)} \; local next
= table.unpack(data \, i + markovOrder \, i + markovOrder) \; model[state][next]
= (model[state][next] or 0)+1 \; end \; \; -- make tables from dict
\; \; local keyTbl = {} \; local nexTbl = {} \; local prbTbl = {} \;
for key \, value in pairs(model) do \; for k \, v in pairs(value) do
\; table.insert(keyTbl \, key) \; table.insert(nexTbl \, k) \; table.insert(prbTbl
\, v) \; end \; end \; \; local keyStringTable = {} \; for i = 1 \,
#keyTbl do \; local keyString = table.concat(keyTbl[i] \, "-") \; keyStringTable[i]
= keyString \; \; print("Key: " \, keyString) \; end \; print("Nex:
" \, table.unpack(nexTbl)) \; print("Prb: " \, table.unpack(prbTbl))
\; \; print("Make a Markov Chain...") \; \; function ofelia.markovChain()
\; \; -- make start key \; \; local startKey = {} \; if ofelia.randomStart
== 1 then \; local randomKey = math.random(#keyTbl) \; startKey = randomKey
\; else \; startKey = 1 \; end \; \; local out = keyTbl[startKey] \;
local markovString = table.concat(keyTbl[startKey] \, "-") \; \; --
make markov chain \; \; for i = 1 \, ofelia.markovChainLength do \;
\; -- weighted random choices \; \; local choices = {} \; local weights
= {} \; for j = 1 \, #keyTbl do \; if markovString == keyStringTable[j]
then \; table.insert(choices \, nexTbl[j]) \; table.insert(weights
\, prbTbl[j]) \; end \; end \; \; -- print ("choices:" \, table.unpack(choices))
\; -- print ("weights:" \, table.unpack(weights)) \; \; local totalWeight
= 0 \; for _ \, weight in pairs(weights) do \; totalWeight = totalWeight
+ weight \; end \; rand = math.random() * totalWeight \; local choice
= nil \; for i \, weight in pairs(weights) do \; if rand < weight then
\; choice = choices[i] \; if math.type(choice) == "integer" then \;
choice = choice * (1.0) \; end \; break \; else \; rand = rand - weight
\; end \; end \; \; table.insert(out \, choice) \; local lastStep =
{} \; table.move(out \, #out - (markovOrder-1) \, #out \, 1 \, lastStep)
\; markovString = table.concat(lastStep \, "-") \; end \; \; keyTbl[startKey]
= {table.unpack(keyTbl[startKey] \, 1 \, markovOrder)} \; return {table.unpack(out
\, markovOrder + 1 \, #out)} \; end \; end \; \;;
#X msg 211 249 randomStart \$1;
#X obj 211 229 tgl 15 1 empty \$0-randomStart randomStart 17 7 0 10
-257985 -1 -1 0 1;
#X obj 38 23 bng 15 250 50 1 empty \$0-sendArrayToMarkovGenerator sendArrayToMarkovGenerator
17 7 0 10 -257985 -1 -1;
#X obj 38 64 ofelia d -c11 -k \$0-sendArrayToMarkovGenerator;
#A set function ofelia.sendArrayToMarkovGenerator() \; local array
= pd.Array("\$0-array") \; local markovArray = array:get(0) \; for
i=1 \, #markovArray do \; markovArray[i] = math.floor(markovArray[i])
\; end \; print ("array: " \, table.unpack(markovArray)) \; return
markovArray \; end \;;
#X obj 48 91 r \$0-receiveList;
#X msg 38 43 sendArrayToMarkovGenerator;
#X obj 197 85 bang~;
#X obj 359 143 mtof;
#X floatatom 359 164 0 0 0 0 - - -;
#X obj 359 185 tabosc4~ \$0-playArray;
#N canvas 0 50 450 250 (subpatch) 0;
#X array \$0-array 67 float 1;
#A 0 11.4697 10.5397 9.91964 9.60963 9.29962 8.9896 8.9896 8.67959
8.67959 8.67959 8.67959 8.67959 8.67959 8.9896 9.60963 10.8497 11.4697
13.9498 15.4999 17.3599 18.29 18.91 16.7399 15.1899 13.3298 11.7797
11.4697 11.4697 11.4697 11.8831 12.2964 12.7098 13.1748 13.6398 14.2598
14.8798 15.6549 16.4299 17.98 19.065 20.1501 22.0101 23.5602 24.3352
26.0403 25.7303 24.1802 17.3599 14.5698 11.4697 10.8497 10.8497 11.4697
11.7797 12.7098 13.6398 14.8798 17.98 20.7701 24.1802 19.53 17.0499
15.1899 12.3997 11.7797 18.6003 18.6003;
#X coords 0 31 66 0 200 100 2 0 0;
#X restore 38 408 graph;
#X obj 38 371 s pd-\$0-sendOtherListsToMarkovGenerator;
#X obj 38 350 array define \$0-playArray 67;
#X obj 38 329 array set \$0-playArray;
#X obj 197 125 spigot;
#X obj 230 105 tgl 15 1 empty \$0-markovAudio markovAudio 17 7 0 10
-257985 -1 -1 1 1;
#X obj 359 124 nbx 5 14 1 500 0 1 empty \$0-pitch pitch 0 -8 0 10 -257985
-1 -1 35 256;
#X obj 359 471 hip~ 5;
#X obj 359 492 dac~;
#X obj 374 344 nbx 5 14 0 100 0 1 empty \$0-volume volume 0 -8 0 10
-257985 -1 -1 10 256;
#X obj 359 450 *~;
#X msg 410 481 \; pd dsp 1;
#X obj 374 426 line~;
#X obj 374 405 pack f 50;
#X obj 374 207 tgl 15 1 empty \$0-mute mute 17 7 0 10 -257985 -1 -1
1 1;
#X obj 374 227 sel 0 1;
#X msg 393 248 0;
#X obj 374 363 spigot;
#X obj 393 269 t f f;
#X obj 374 290 t b b;
#X msg 403 311 1;
#X obj 410 460 loadbang;
#X obj 60 165 bng 15 250 50 1 empty \$0-RmakeMarkov makeMarkovMatrix
17 7 0 10 -257985 -1 -1;
#X obj 374 384 / 1000;
#X connect 0 0 5 1;
#X connect 1 0 5 0;
#X connect 2 0 5 0;
#X connect 3 0 4 0;
#X connect 4 0 5 0;
#X connect 5 0 19 0;
#X connect 6 0 5 0;
#X connect 7 0 6 0;
#X connect 8 0 11 0;
#X connect 9 0 1 0;
#X connect 10 0 1 0;
#X connect 11 0 9 0;
#X connect 12 0 20 0;
#X connect 13 0 14 0;
#X connect 14 0 15 0;
#X connect 15 0 26 0;
#X connect 20 0 2 0;
#X connect 21 0 20 1;
#X connect 22 0 13 0;
#X connect 23 0 24 0;
#X connect 25 0 33 0;
#X connect 26 0 23 0;
#X connect 28 0 26 1;
#X connect 29 0 28 0;
#X connect 30 0 31 0;
#X connect 31 0 35 0;
#X connect 31 1 32 0;
#X connect 32 0 34 0;
#X connect 33 0 39 0;
#X connect 34 0 29 0;
#X connect 34 1 33 1;
#X connect 35 0 25 0;
#X connect 35 1 36 0;
#X connect 36 0 33 1;
#X connect 37 0 27 0;
#X connect 38 0 5 0;
#X connect 39 0 29 0;
